<template>
  <!-- Start Content-->
  <div class="container-fluid">

    <!-- start page title -->
    <div class="row">
      <div class="col-12">
        <div class="page-title-box">
          <h4 class="page-title">Товары ({{products.length}})</h4>
        </div>
      </div>
    </div>
    <!-- end page title -->

    <SpinnerComponent v-if="isLoading"></SpinnerComponent>
    <div class="row" v-else-if="isManufacturer">
      <div class="col-12">
        <div class="card-box">
          <div class="row">
            <div class="col-lg-8" v-if="false">
              <form class="form-inline">
                <div class="form-group">
                  <label for="inputPassword2" class="sr-only">Search</label>
                  <input type="search" class="form-control" id="inputPassword2" placeholder="Search...">
                </div>
                <div class="form-group mx-sm-3">
                  <label for="status-select" class="mr-2">Sort By</label>
                  <select class="custom-select" id="status-select">
                    <option selected="">All</option>
                    <option value="1">Popular</option>
                    <option value="2">Price Low</option>
                    <option value="3">Price High</option>
                    <option value="4">Sold Out</option>
                  </select>
                </div>
              </form>
            </div>
            <div class="col-lg-12">
              <div class="text-lg-right mt-3 mt-lg-0">
                <NuxtLink to="/products/add" class="btn btn-danger waves-effect waves-light"><i class="mdi mdi-plus-circle mr-1"></i>Добавить товар</NuxtLink>
                <NuxtLink to="/products/upload" class="btn btn-danger waves-effect waves-light"><i class="mdi mdi-plus-circle mr-1"></i>Загрузить из файла</NuxtLink>
              </div>
            </div><!-- end col-->
          </div> <!-- end row -->
        </div> <!-- end card-box -->
      </div> <!-- end col-->
    </div>
    <!-- end row-->
    <template v-if="products.length > 0">
    <div class="row">
      <div class="col-md-6 col-xl-3" v-for="product in products">
        <div class="card-box product-box">

          <div class="product-action" v-if="isManufacturer">
            <NuxtLink :to="'/products/'+ product.slug + '/edit'" class="btn btn-success btn-xs waves-effect waves-light"><i class="mdi mdi-pencil"></i></NuxtLink>
          </div>

          <div class="bg-light">
            <NuxtLink :to="'/products/'+product.slug"><img :src="product.image" alt="product-pic" class="img-fluid" /></NuxtLink>
          </div>

          <div class="product-info">
            <div class="row align-items-center">
              <div class="col">
                <h5 class="font-16 mt-0 sp-line-1"><NuxtLink :to="'/products/'+product.slug" class="text-dark">{{product.name}}</NuxtLink> </h5>
                <h5 class="m-0"> <span class="text-muted"> В наличии : {{ product.stock }} шт.</span></h5>
              </div>
              <div class="col-auto">
                <div class="product-price-tag">
                  {{ product.price}}
                </div>
              </div>
            </div> <!-- end row -->
          </div> <!-- end product info-->
        </div> <!-- end card-box-->
      </div> <!-- end col-->
    </div>
    <!-- end row-->
    </template>
    <template v-else>
      <div class="card-box" style="text-align:center">
        <div>Нет данных для отображения.</div>
        <div v-if="isManufacturer"><NuxtLink :to="'/products/upload'">Загрузите товары</NuxtLink></div>
        <div v-else><NuxtLink :to="'/tenders/create'">Создайте запрос</NuxtLink></div>
      </div>
    </template>

    <Pagination v-model="page" :pageCount="pageCount" :route="this.$route" v-if="pageCount > 1"></Pagination>

  </div> <!-- container -->
</template>

<script>
import Pagination from "~/components/Pagination";
import SpinnerComponent from "~/components/SpinnerComponent";

export default {
  name: "index",
  components: {SpinnerComponent, Pagination},
  data(){
    return{
      products: [],
      pageCount: 1,
      isLoading: false,
      isManufacturer: false,
    }
  },
  beforeCreate () {
    let current_page = this.$route.query.page || 1;
    this.$axios.get('/products')
      .then(resp => {
          this.getProductData(resp.data.products);
          //this.page = resp.data.current_page;
          this.pageCount = resp.data.products.last_page;
          this.isManufacturer = resp.data.is_manufacturer;
          this.isLoading = false;
      }).catch(function(){
          console.log('Error');
      });
  },
  computed: {
    page: function () {
      return this.$route.query.page || 1
    }
  },
  watch: {
    async page() {
      this.$router.replace({ path: '/products', query: { page: this.page } });
      this.isLoading = true;
      this.$axios.get('/products?page='+this.page)
        .then(resp => {
          this.getProductData(resp.data.data);
          //this.page = resp.data.current_page;
          this.pageCount = resp.data.products.last_page;
          this.isLoading = false;
        }).catch(function(){
        console.log('Error');
      });
    },
  },
  methods:{
    getProductData(products){
      this.products = [];
      let product;
       for(product in products){
         let image;
         if(typeof products[product].media[0] === 'undefined'){
            image = '/assets/images/products/default.jpg'
         }else{
           image = 'http://site.test/storage/' + products[product].media[0].id + '/' + products[product].media[0].file_name;
         }
         let product_data = {};
         product_data = {
           'name': products[product].name,
           'slug': products[product].slug,
           'price': products[product].price,
           'rrp': products[product].recommended_retail_price,
           'stock': products[product].stock,
           'image': image
         };
         this.products.push(product_data);
       }
    }
  }
}
</script>

<style scoped>

</style>
